/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net) //当前活动便签项
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.model; //设置包

import android.appwidget.AppWidgetManager; //该文件调用的其他类
import android.content.ContentUris;
import android.content.Context;
import android.database.Cursor; //导入其它用来调用的类
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.data.Notes; //小米便签操作的整体属性
import net.micode.notes.data.Notes.CallNote;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.Notes.TextNote;
import net.micode.notes.tool.ResourceParser.NoteBgResources;


public class WorkingNote { //设置一个WorkingNote类，包含一些正在进行中的note的属性
    // Note for the working note
    private Note mNote; //声明一个Note类型的变量
    // Note Id
    private long mNoteId;  //声明便签content
    // Note content
    private String mContent; //声明便签mode
    // Note mode
    private int mMode; //判断是否为清单模式

    private long mAlertDate; // 设置闹钟时间

    private long mModifiedDate; //最后一次修改的时间

    private int mBgColorId; //背景颜色所对应的ID号

    private int mWidgetId; //桌面挂件所对应的ID

    private int mWidgetType; //桌面挂件的格式

    private long mFolderId; //文件夹所对应的ID

    private Context mContext; //当前便签的上下文
 
    private static final String TAG = "WorkingNote"; //.声明 一个叫做DATA_PROJECTION字符串数组

    private boolean mIsDeleted; //是否应该被删除

    private NoteSettingChangedListener mNoteSettingStatusListener; //判断便签设置值是否改变的监听器

    public static final String[] DATA_PROJECTION = new String[] {  //声明 NOTE_PROJECTION字符串数组
            DataColumns.ID,
            DataColumns.CONTENT,
            DataColumns.MIME_TYPE,
            DataColumns.DATA1,
            DataColumns.DATA2,
            DataColumns.DATA3,
            DataColumns.DATA4,
    };

    public static final String[] NOTE_PROJECTION = new String[] { //保存便签属性信息的string数组
            NoteColumns.PARENT_ID,
            NoteColumns.ALERTED_DATE,
            NoteColumns.BG_COLOR_ID,
            NoteColumns.WIDGET_ID,
            NoteColumns.WIDGET_TYPE,
            NoteColumns.MODIFIED_DATE
    }; //设置数据在哪一列

    private static final int DATA_ID_COLUMN = 0; //以下定义的整形是上述两个列表中各元素的索引

    private static final int DATA_CONTENT_COLUMN = 1;

    private static final int DATA_MIME_TYPE_COLUMN = 2;

    private static final int DATA_MODE_COLUMN = 3;

    private static final int NOTE_PARENT_ID_COLUMN = 0; //. 以下6个常量表示便签投影的0-5列

    private static final int NOTE_ALERTED_DATE_COLUMN = 1;

    private static final int NOTE_BG_COLOR_ID_COLUMN = 2;

    private static final int NOTE_WIDGET_ID_COLUMN = 3;

    private static final int NOTE_WIDGET_TYPE_COLUMN = 4;

    private static final int NOTE_MODIFIED_DATE_COLUMN = 5;

    // New note construct
    private WorkingNote(Context context, long folderId) { //.声明一个新的note construct
        mContext = context; //构造函数声明
        mAlertDate = 0; //默认提醒日期为0
        mModifiedDate = System.currentTimeMillis(); //获取系统当前时间的方法，返回当前时间
        mFolderId = folderId; //默认最后一次修改日期为当前时间
        mNote = new Note(); //加载一个已存在的便签
        mNoteId = 0;
        mIsDeleted = false;
        mMode = 0;
        mWidgetType = Notes.TYPE_WIDGET_INVALIDE;
    }

    // Existing note construct
    private WorkingNote(Context context, long noteId, long folderId) { //载入便签
        mContext = context; //通过数据库调用query函数找到第一个条目
        mNoteId = noteId;
        mFolderId = folderId;
        mIsDeleted = false;
        mNote = new Note();
        loadNote(); //加载便签
    }

    private void loadNote() { //输出mNoteId的所有属性值，比如位置信息、颜色信息、控件信息等
        Cursor cursor = mContext.getContentResolver().query( //判断是否存储相应信息
                ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, mNoteId), NOTE_PROJECTION, null,
                null, null);

        if (cursor != null) { //若存在,则存储相应信息
            if (cursor.moveToFirst()) { //通过判断cursor.moveToFirst()的值为true或false来确定查询结果是否为空
                mFolderId = cursor.getLong(NOTE_PARENT_ID_COLUMN); //获取文档的属性
                mBgColorId = cursor.getInt(NOTE_BG_COLOR_ID_COLUMN); //关闭cursor游标
                mWidgetId = cursor.getInt(NOTE_WIDGET_ID_COLUMN);
                mWidgetType = cursor.getInt(NOTE_WIDGET_TYPE_COLUMN);
                mAlertDate = cursor.getLong(NOTE_ALERTED_DATE_COLUMN);
                mModifiedDate = cursor.getLong(NOTE_MODIFIED_DATE_COLUMN);
            }
            cursor.close(); //不存在时返回错误信息
        } else { //否则说明不存在这个便签，加载错误
            Log.e(TAG, "No note with id:" + mNoteId); //未能找到此note,返回异常
            throw new IllegalArgumentException("Unable to find note with id " + mNoteId); //.抛出异常，找不到NoteID
        }
        loadNoteData(); // 调用方法loadNoteData，导入便签的内容。
    }

    private void loadNoteData() { //加载NoteData
        Cursor cursor = mContext.getContentResolver().query(Notes.CONTENT_DATA_URI, DATA_PROJECTION, //调用query函数查找到便签ID为mNoteId的位置，并将光标移动到该位置
                DataColumns.NOTE_ID + "=?", new String[] {
                    String.valueOf(mNoteId)
                }, null);  //如果找到的信息不为空，就把内容反馈给用户


        if (cursor != null) { //光标存在时，将光标移动到便签的起始位置
            if (cursor.moveToFirst()) { //通过判断cursor.moveToFirst()的值为true或false来确定查询结果是否为空
                do {
                    String type = cursor.getString(DATA_MIME_TYPE_COLUMN);
                    if (DataConstants.NOTE.equals(type)) {
                        mContent = cursor.getString(DATA_CONTENT_COLUMN);
                        mMode = cursor.getInt(DATA_MODE_COLUMN);
                        mNote.setTextDataId(cursor.getLong(DATA_ID_COLUMN));
                    } else if (DataConstants.CALL_NOTE.equals(type)) {
                        mNote.setCallDataId(cursor.getLong(DATA_ID_COLUMN));
                    } else {
                        Log.d(TAG, "Wrong note type with type:" + type);
                    }
                } while (cursor.moveToNext());
            }
            cursor.close();
        } else { //否则说明不存在这个便签，加载错误
            Log.e(TAG, "No data with id:" + mNoteId); //未能找到此note,返回异常
            throw new IllegalArgumentException("Unable to find note's data with id " + mNoteId); //抛出异常，找不到NoteID
        }
    }

    public static WorkingNote createEmptyNote(Context context, long folderId, int widgetId, //创建一个新便签的构造函数
            int widgetType, int defaultBgColorId) {
        WorkingNote note = new WorkingNote(context, folderId); //创建一个新的包含文件ID和内容的便签
        note.setBgColorId(defaultBgColorId); //设置背景颜色
        note.setWidgetId(widgetId); // 设定布局
        note.setWidgetType(widgetType); //设置窗口类型
        return note;
    }

    public static WorkingNote load(Context context, long id) { //导入一个新的正在写入的便签
        return new WorkingNote(context, id, 0); //返回便签
    }

    public synchronized boolean saveNote() { //保存便签，成功保存返回true，否则返回false
        if (isWorthSaving()) { //判断是否有价值去保存
            if (!existInDatabase()) { //判断是否存在数据库中
                if ((mNoteId = Note.getNewNoteId(mContext, mFolderId)) == 0) { //没有成功创建便签则记录异常日志
                    Log.e(TAG, "Create new note fail with id:" + mNoteId);
                    return false;
                }
            }

            mNote.syncNote(mContext, mNoteId); //同步便签内容及便签id

            /**
             * Update widget content if there exist any widget of this note
             */
            if (mWidgetId != AppWidgetManager.INVALID_APPWIDGET_ID //判断窗口大小是否变化，如果变化也要保存这个变化
                    && mWidgetType != Notes.TYPE_WIDGET_INVALIDE
                    && mNoteSettingStatusListener != null) {
                mNoteSettingStatusListener.onWidgetChanged();
            }
            return true;
        } else {
            return false;
        }
    }

    public boolean existInDatabase() { //判断便签是否已经存在于数据库中，mNoteID >0时存在，返回true，否则返回false
        return mNoteId > 0;
    }

    private boolean isWorthSaving() { //判断是否有保存的必要性
        if (mIsDeleted || (!existInDatabase() && TextUtils.isEmpty(mContent)) //已被删除或者不在数据库中但是是空便签或者已经在数据库中但本地没有修改过，都不保存
                || (existInDatabase() && !mNote.isLocalModified())) {
            return false;
        } else {
            return true; //其余情况，要保存，返回true
        }
    }

    public void setOnSettingStatusChangedListener(NoteSettingChangedListener l) { //设置监听“设置状态改变”
        mNoteSettingStatusListener = l;
    }

    public void setAlertDate(long date, boolean set) { //设置提醒日期
        if (date != mAlertDate) { //若 mAlertDate与data不同，则更改mAlertDate并设定NoteValue
            mAlertDate = date;  //为设置的日期打标签
            mNote.setNoteValue(NoteColumns.ALERTED_DATE, String.valueOf(mAlertDate));
        }
        if (mNoteSettingStatusListener != null) {  //判断是否为空
            mNoteSettingStatusListener.onClockAlertChanged(date, set);
        }
    }

    public void markDeleted(boolean mark) { //判断是否为空
        mIsDeleted = mark; //设定标记
        if (mWidgetId != AppWidgetManager.INVALID_APPWIDGET_ID
                && mWidgetType != Notes.TYPE_WIDGET_INVALIDE && mNoteSettingStatusListener != null) {
                mNoteSettingStatusListener.onWidgetChanged(); //调用mNoteSettingStatusListener的 onWidgetChanged方法
        }
    } //调用mNoteSettingStatusListener的 onWidgetChanged方法

    public void setBgColorId(int id) {  //设定背景颜色
        if (id != mBgColorId) { //判断并更新背景颜色
            mBgColorId = id;
            if (mNoteSettingStatusListener != null) {
                mNoteSettingStatusListener.onBackgroundColorChanged();
            }
            mNote.setNoteValue(NoteColumns.BG_COLOR_ID, String.valueOf(id));
        }
    }

    public void setCheckListMode(int mode) { //设置检查列表模式
        if (mMode != mode) { //.当mMode和mode不相同时进行设定
            if (mNoteSettingStatusListener != null) {
                mNoteSettingStatusListener.onCheckListModeChanged(mMode, mode);  //设定之后更改mMode
            }
            mMode = mode;
            mNote.setTextData(TextNote.MODE, String.valueOf(mMode)); //储存mode记录的文本数据
        }
    }

    public void setWidgetType(int type) { //设置窗口类型
        if (type != mWidgetType) {
            mWidgetType = type; //调用Note的setNoteValue方法更改WidgetType
            mNote.setNoteValue(NoteColumns.WIDGET_TYPE, String.valueOf(mWidgetType));
        }
    }

    public void setWidgetId(int id) {  //设置窗口编号
        if (id != mWidgetId) {  //判断传入是否与当前id一样，否则更改为传入id
            mWidgetId = id;
            mNote.setNoteValue(NoteColumns.WIDGET_ID, String.valueOf(mWidgetId));
        } //调用Note的setNoteValue方法更改WidgetId
    }

    public void setWorkingText(String text) { //设定WorkingText
        if (!TextUtils.equals(mContent, text)) { // 判断文本内容是否相同，否则更新文本
            mContent = text; //调用Note的setTextData方法更改WorkingText
            mNote.setTextData(DataColumns.CONTENT, mContent);
        }
    }

    public void convertToCallNote(String phoneNumber, long callDate) { //转换成电话提醒的便签
        mNote.setCallData(CallNote.CALL_DATE, String.valueOf(callDate));
        mNote.setCallData(CallNote.PHONE_NUMBER, phoneNumber);
        mNote.setNoteValue(NoteColumns.PARENT_ID, String.valueOf(Notes.ID_CALL_RECORD_FOLDER));
    }

    public boolean hasClockAlert() { //检测是否有时钟提醒，mAlertDate > 0返回真，否则返回假
        return (mAlertDate > 0 ? true : false);
    }

    public String getContent() {  //获取便签内容
        return mContent;
    }

    public long getAlertDate() { //获取待提醒日期
        return mAlertDate;
    }

    public long getModifiedDate() { //获取修改之后的日期
        return mModifiedDate;
    }

    public int getBgColorResId() { //获取背景颜色id
        return NoteBgResources.getNoteBgResource(mBgColorId);
    }

    public int getBgColorId() { //获取背景颜色id
        return mBgColorId;
    }

    public int getTitleBgResId() { //获取标题背景颜色id
        return NoteBgResources.getNoteTitleBgResource(mBgColorId);
    }

    public int getCheckListMode() {  //获取检查列表模式
        return mMode;
    }

    public long getNoteId() { //获取便签编号
        return mNoteId;
    }

    public long getFolderId() { //获取所在文件夹编号
        return mFolderId;
    }

    public int getWidgetId() { //获取窗口编号
        return mWidgetId;
    }

    public int getWidgetType() { //创建接口 NoteSettingChangedListener,便签更新监视；
为NoteEditActivity提供接口
        return mWidgetType;
    }

    public interface NoteSettingChangedListener { //监听便签设置是否改变
        /**
         * Called when the background color of current note has just changed
         */
        void onBackgroundColorChanged(); //背景颜色改变按钮

        /**
         * Called when user set clock
         */
        void onClockAlertChanged(long date, boolean set); //提醒时间按钮，可进行时间的更改和提醒的开关

        /**
         * Call when user create note from widget
         */
        void onWidgetChanged(); //窗口改变

        /**
         * Call when switch between check list mode and normal mode
         * @param oldMode is previous mode before change
         * @param newMode is new mode
         */
        void onCheckListModeChanged(int oldMode, int newMode); //列表检查模式改变
    }
}
